﻿using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System;
using System.Collections.Generic;

namespace PassValueToTemplateField
{
    class AddValueToField
    {
        private static String apiUrl = "https://sandbox.esignlive.com/api"; //change to the instance you're using
        private static String apiKey = "YOUR_API_KEY"; //replace YOUR_API_KEY with your api key for your account

        public static void Main(string[] args)
        {
            EslClient eslClient = new EslClient(apiKey, apiUrl);

            Placeholder placeholder1 = new Placeholder("Signer1");
            string placeholder1Id = placeholder1.Id;

            DocumentPackage myTemplate = PackageBuilder.NewPackageNamed("Create Package From Existing Template")
                .WithSettings(DocumentPackageSettingsBuilder.NewDocumentPackageSettings())
                .WithSigner(SignerBuilder.NewSignerPlaceholder(placeholder1))
                .WithDocument(DocumentBuilder.NewDocumentNamed("My Document")
                    .FromFile("C:/Users/mwilliams/Downloads/sampleAgreement.pdf")
                    .WithSignature(SignatureBuilder.SignatureFor(placeholder1)
                        .AtPosition(100,600)
                        .WithSize(300,30)
                        .OnPage(0)
                        .WithField(FieldBuilder.Label()
                            .AtPosition(100,650)
                            .OnPage(0)
                            .WithName("StaticLabel"))
                        .WithField(FieldBuilder.TextField()
                            .AtPosition(400,650)
                            .OnPage(0)
                            .WithName("EditableText"))))
                .Build();

            PackageId templateId = eslClient.CreateTemplate(myTemplate);

            //PackageId templateId = new PackageId("X39lbEATgVzXSQQVNO4towrEqzQ=");

            DocumentPackage tempDocPackage = eslClient.GetPackage(templateId);
            string signer1Id = tempDocPackage.Placeholders[0].Id;
            
            DocumentPackage myDocPackage = PackageBuilder.NewPackageNamed("Create Package From Existing Template")
                .WithSettings(DocumentPackageSettingsBuilder.NewDocumentPackageSettings())
                .WithSigner(SignerBuilder.NewSignerWithEmail("email.address@example.com")
                    .WithFirstName("MWilliams")
                    .WithLastName("Silanis")
                    .Replacing(new Placeholder(signer1Id)))
                .Build();

            PackageId packageId = eslClient.CreatePackageFromTemplate(templateId, myDocPackage);

            DocumentPackage myPackage = eslClient.GetPackage(packageId);
            Document mydoc = myPackage.Documents[1];
            string docId = mydoc.Id;
            SignatureId sigId = mydoc.Signatures[0].Id;
            Field Field1 = mydoc.Signatures[0].Fields[1];
            Field1.Value = "My injected value";
            Field Field2 = mydoc.Signatures[0].Fields[0];
            Field2.Value = "My editable value";
            eslClient.ApprovalService.ModifyField(packageId, docId, sigId, Field1);
            eslClient.ApprovalService.ModifyField(packageId, docId, sigId, Field2);
            eslClient.SendPackage(packageId);
        }
    }
}
